//
//  FlutterAdsBannerViewController.m
//  flutter_ads
//
//  Created by 彭新凯 on 2019/11/19.
//

#import "FlutterAdsBannerViewController.h"
#import "GDTMobBannerView.h"

@interface FlutterAdsBannerViewController ()<GDTMobBannerViewDelegate>
@property (nonatomic, strong) GDTMobBannerView *bannerView;

@end

@implementation FlutterAdsBannerViewController{
    //FlutterIosTextLabel 创建后的标识
    int64_t _viewId;
    UIView * _bannerBaseView;
    //消息回调
    FlutterBasicMessageChannel *_channel;
    NSString *gdtAppID;
    NSString *placementID;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
}

- (instancetype)initWithWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id)args binaryMessenger:(NSObject<FlutterBinaryMessenger> *)messenger{
    if ([super init]) {
        _bannerBaseView = [[UIView alloc] initWithFrame:frame];
        _viewId = viewId;
        // 注册通道
        NSString* channelName = @"plugins.nova.ads.event/bannerview";
        _channel = [FlutterBasicMessageChannel messageChannelWithName:channelName binaryMessenger:messenger codec:[FlutterStringCodec sharedInstance]];// 编码方式是个坑
        // 接收参数
        NSDictionary *dic = args;
        gdtAppID = dic[@"gdtAppID"];
        placementID = dic[@"placementID"];
        [self.view addSubview:_bannerBaseView];
        [self->_bannerBaseView addSubview:self.bannerView];
        [_bannerView loadAdAndShow];
    }
    return self;
}

#pragma mark - property getter
- (GDTMobBannerView *)bannerView
{
    if (!_bannerView) {
        CGRect rect = {CGPointZero, GDTMOB_AD_SUGGEST_SIZE_320x50};
//        NSString *placementId = @"4090812164690039";
//        NSString *gdtAppID = @"1105344611";
        
        _bannerView = [[GDTMobBannerView alloc] initWithFrame:rect appId:gdtAppID placementId:placementID];
        _bannerView.accessibilityIdentifier = @"banner_ad";
        _bannerView.currentViewController = self;
//        _bannerView.interval = 60;
        _bannerView.isAnimationOn = YES;
        _bannerView.showCloseBtn = NO;
        _bannerView.delegate = self;
    }
    return _bannerView;
}

- (nonnull UIView *)view {
    return _bannerView;
}

#pragma mark - GDTMobBannerViewDelegate
// 请求广告条数据成功后调用
//
// 详解:当接收服务器返回的广告数据成功后调用该函数
- (void)bannerViewDidReceived
{
    NSLog(@"banner Received");
    [_channel sendMessage:@"finish"];
}

// 请求广告条数据失败后调用
//
// 详解:当接收服务器返回的广告数据失败后调用该函数
- (void)bannerViewFailToReceived:(NSError *)error
{
    NSLog(@"banner failed to Received : %@",error);
    [_channel sendMessage:@"failure"];
}

// 广告栏被点击后调用
//
// 详解:当接收到广告栏被点击事件后调用该函数
- (void)bannerViewClicked
{
    NSLog(@"banner clicked");
}

// 应用进入后台时调用
//
// 详解:当点击下载或者地图类型广告时，会调用系统程序打开，
// 应用将被自动切换到后台
- (void)bannerViewWillLeaveApplication
{
    NSLog(@"banner leave application");
}


-(void)bannerViewDidDismissFullScreenModal
{
    NSLog(@"%s",__FUNCTION__);
}

-(void)bannerViewWillDismissFullScreenModal
{
    NSLog(@"%s",__FUNCTION__);
}

-(void)bannerViewWillPresentFullScreenModal
{
    NSLog(@"%s",__FUNCTION__);
}

-(void)bannerViewDidPresentFullScreenModal
{
    NSLog(@"%s",__FUNCTION__);
}



/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
