import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

typedef AdsIsFinish = void Function();

typedef AdsIsFailure = void Function();


typedef AdsTick = void Function(num);

class AdsBannerView extends StatefulWidget {
  final AdsIsFinish asdIsFinish;
  final AdsTick adsTick;
  final AdsIsFailure adsFailure;
  final String appid;
  final String placementID;

  const AdsBannerView({
    Key key,
    this.asdIsFinish,
    this.adsTick,
    this.adsFailure,
    this.appid,
    this.placementID
  })
      : super(key: key);


  @override
  _AdsBannerViewState createState() => _AdsBannerViewState();
}

// 设置事件监听方法
class _AdsBannerViewState extends State<AdsBannerView> {
  static const BasicMessageChannel<dynamic> messageChannel =
  const BasicMessageChannel(
      'plugins.nova.ads.event/bannerview', StringCodec());
  @override
  void initState() {
    super.initState();
    messageChannel.setMessageHandler((value) {
      if (mounted) {
        if (value == "finish") {
          this.widget.asdIsFinish();
        } else if (value == "failure") {
          this.widget.adsFailure();
        }
      }
    });
  }

  @override
  void dispose() {
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    if (defaultTargetPlatform == TargetPlatform.android) {
      return SizedBox(
        height: 100,
        child: AndroidView(viewType: 'plugins.nova.ads/bannerview'),
      );
    } else {
      return UiKitView(
        viewType: 'com.flutter_to_ads_banner_view',
        creationParams: {
          "gdtAppID": this.widget.appid,
          "placementID": this.widget.placementID,
        },
        creationParamsCodec: const StandardMessageCodec(),
      );
    }
  }
}
